<template>
  <div>
    <div>config</div>
    <div>
      <div>from {{ getFromTime }}</div>
      <div>to {{ getToTime }}</div>
      <!-- Todo: show validation ToTime Should Be After FromTime -->
    </div>
    <div>
      <div>
        <div>
          Expected Shuttle Duration{{
            durationFromSecondes(shuttleDuration - fromTimeInSeconds)
          }}
        </div>
        <div>
          Actual Shuttle Duration{{
            durationFromSecondes(getActualTotalDuration - fromTimeInSeconds)
          }}
        </div>
        <div>
          Shuttle Total Distance{{ distanceFormatter(getTotalDistance) }}
        </div>
      </div>

      <div>
        tripEndTimeTolerance : {{ tripEndTimeTolerance }}
        <v-text-field
          v-model.number="tripEndTimeTolerance"
          type="number"
          min="0"
        ></v-text-field>
      </div>
      <div>
        durationBetweenTripRuns : {{ durationBetweenTripRuns }}
        <v-text-field
          v-model.number="durationBetweenTripRuns"
          type="number"
          min="0"
        ></v-text-field>
      </div>
      <div>
        stopDuration : {{ stopDuration }}
        <v-text-field
          v-model.number="stopDuration"
          type="number"
          min="0"
        ></v-text-field>
      </div>
    </div>

    triplist
    <div v-for="(trip, index) in trips" :key="index" style="border: solid 1px">
      <TripPath
        :index="index"
        :fromTime="index == 0 ? fromTimeInSeconds : trips[index - 1].totalTime"
      />
    </div>
  </div>
</template>

<script>
import TripPath from './TripPath.vue';
import { mapGetters, mapState, mapActions, mapMutations } from 'vuex';
import { durationFromSecondes, distanceFormatter } from '../shuttlingService';

export default {
  name: 'trip-list',
  components: { TripPath },
  computed: {
    ...mapState({
      config: (state) => state.config,
    }),
    ...mapGetters('config', [
      'getFromTime',
      'getToTime',
      'fromTimeInSeconds',
      'shuttleDuration',
      'getRegenerateOrRemoveDependencies',
    ]),
    ...mapGetters('trips', {
      trips: 'getTrips',
      getActualTotalDuration: 'getActualTotalDuration',
      getSum: 'getSum',
      isProcessDone: 'isProcessDone',
      getFirstTrip: 'getFirstTrip',
      getBaseTrip: 'getBaseTrip',
      getTotalDistance: 'getTotalDistance',
    }),
    tripEndTimeTolerance: {
      get() {
        return this.config.tripEndTimeTolerance;
      },
      set(value) {
        this.updateTripEndTimeTolerance(value);
      },
    },
    durationBetweenTripRuns: {
      get() {
        return this.config.durationBetweenTripRuns;
      },
      set(value) {
        this.updateDurationBetweenTripRuns(value);
      },
    },
    stopDuration: {
      get() {
        return this.config.stopDuration;
      },
      set(value) {
        this.updateStopDuration(value);
      },
    },
  },
  methods: {
    ...mapActions('trips', ['removeExceededStations', 'generateRuns']),
    ...mapMutations('config', [
      'updateTripEndTimeTolerance',
      'updateDurationBetweenTripRuns',
      'updateStopDuration',
    ]),
    durationFromSecondes,
    distanceFormatter,
  },
  data: function () {
    return {};
  },
  watch: {
    getRegenerateOrRemoveDependencies: {
      handler(val, oldVal) {
        if (this.getSum > 0 && this.isProcessDone.done) {
          if (val > oldVal) {
            if (
              this.getActualTotalDuration +
                this.getBaseTrip?.statistics?.duration +
                this.stopDuration *
                  (this.getBaseTrip?.statistics?.legs?.length - 1) <
              this.shuttleDuration
            ) {
              this.generateRuns();
            }
          } else {
            if (this.trips.at(-1).totalTime > this.shuttleDuration) {
              this.removeExceededStations();
            }
          }
        }
      },
    },
  },
};
</script>

<style lang="scss" scoped></style>
